#GTK_standard - collection of often used GTK related items

use strict;

use Gtk;
use Gtk::Atoms;
use Gtk::Gdk;

sub destroy_window {
	my($widget, $windowref, $w2) = @_;

	$windowref = undef;
	if ( defined $w2 ) {
		$w2 = undef;
	}
	return 0;
}

sub standard_window {
	my ($x_pos, $y_pos, $x_size, $y_size, $title) = @_; # i guess these are what they are

	my $window = new Gtk::Window "toplevel" ;
	$window->set_uposition($x_pos, $y_pos);
	if ( ! ( $x_size == -1 )) {
		print "Setting window size to $x_size, $y_size \n";
		$window->set_usize($x_size, $y_size);
	}
	$window->signal_connect("destroy", \&destroy_window, \$window);
	$window->signal_connect("delete_event", \&destroy_window, \$window);
	$window->set_title( "$title" );
	$window->border_width(0);
	$window->grab_focus;
	$window->show;

	return $window;
}

sub standard_vbox {
	my ($border_width, $container, $expand, $fill, $padding) = @_;

	my ($item);
	$item = new Gtk::VBox(0,0);
	$item->border_width( $border_width );
	if( defined $container ) {
		if( defined $expand ) {
			$container->pack_start($item, $expand, $fill, $padding );
		}
		else {
			$container->add($item);
		}
	} 
	$item->show;
	return $item;
}

sub standard_hbox {
	my ($border_width, $container, $expand, $fill, $padding) = @_;

	my( $item );
	$item = new Gtk::HBox(0,10);
	$item->border_width( $border_width );
	if ( defined $container ) {
		if ( defined $expand ) {
			$container->pack_start($item, $expand, $fill, $padding );
		}
		else {
			$container->add($item);
		}
	}
	$item->show;
	return $item;
}

sub standard_label {
	my ($label_text, $container, $expand, $fill, $padding) = @_;

	my($label) = new Gtk::Label $label_text;

#	$label->set_alignment(0.0, 0.5);
	if( ! defined $expand ) {
		$container->add($label);
	} 
	else {
		$container->pack_start($label, $expand, $fill, $padding );
	}
	$label->show;
	return $label;
}

sub table_button {
	my ($button_text, $clicked_handler) = @_;

	my( $button ) = new Gtk::Button( $button_text );
	if( defined $clicked_handler ) {
		$button->signal_connect('clicked', $clicked_handler );
	}
	return $button;
}

sub do_exit {
	print "done!\n";
	Gtk->exit(0);
}

1;
