#!/usr/bin/perl -w
# xinstaller - Started by Brian Bresen <bbresen@linuxppc.org>
# Copyrite Brian Bresen - released under the GPL

#TITLE: xinstaller ( was xli.pl )
#REQUIRES: Gtk

use Gtk;
use Gtk::Atoms;
use Gtk::Gdk;

use strict 'vars';

init Gtk;

my $VERSION = "3.3.3";		#The version number  
my $DATE = "Jan 14 1999";	#

my $in_method = "local";	#The way we will install
my $ftp_url;			#url to RedHat dir on a ftp site
my %map;			#The Install Map
my %rpmlist;			#The RPM List
my %rpmlisttree;		#A hash of the rpm list treeitems
my %rpmlisttreereverse;		#A hash of the rpm list treeitems
my @rpmlistcurrent;		#A List of the currently installed rpms
my %sets;			#A hash of the treeitems
my %hdlistinfo;			#The hdlistinfo
my($is_upgrade) = 0;		#0 for install, 1 for upgrade
my($net_set) = 0;		#State if we need net setup for NFS or FTP
my $in_dir = "/tmp/install/";	#the dir with the install files in it
my $out_dir = "/mnt/install/";	#the dir we will install to
my %mount_fstab;	#list of drives selected to install
my @list_bases = ("");	#list of package sets to install
my $menu_window;	#menu to choose steps to do
my $entry_window;	#extra entry windows i will use
my $package_list;	#list of packages to install
my $packages_window;	#choose each rpm individually
my %drive_hash;		#my drives for hash, or um my...
my %net_devs;		#my network devices
my %my_widgets;		#network setup widgets
my $root_passwd;	#hmmmm
my $rpm_label;		#what package is installing
my $prep_install = 0;	#flag for PReP install
my $prepboot;			# PReP boot partition
my %mke2_mount; 	#widgets values
my $wget = "wget -c -t 4 ";	#The wget command - add -q for quiet mode
my $root_dev;

my $testing = 0;	#for future testing purposes
#
# %drive_hash -
#	%dev - (e.g. %hda %sda)
#		%p_no - (e.g. %1 %2 %16)
#			( $type $name $length $base $size )

##Step window global vars
my $main_window;	# Take a guess
my $method_window;	#Install/upgrade from where
my $update_window;	#update the installer itself
my $drives_window;	#Choose which drive
my $pdisk_window;	#partition disk ala druid
my $pswap_window;	#choose swap
my $mount_window;	#choose root partition and other
my $comps_window;	#choose packages to install
my $passwd_window;	#choose a root passwd
my $net_window;		#add a network device
my $bootx_window;	#get info on using bootx to boot linux
my $cngrat_window;	#get a pat on the back you made it
my $language_window;
my $ButtonPressed;	#Set to the name of the last button clicked
my $CurrentWindow;	# The window currently being drawn in
my %words;		# hash of words for internationalization
my $CurrentRoot;	# What device to use in BootX
my $ProgressBar;	# The progress bar to update
my $ProgressEntry;	# The progress entrybox to update
my $MasterCounter;	# A global counter for number of packages to install
my $MasterCounterDone;	# A global counter for number of packages installed
my $CheckDisk = FALSE;	# A flag for checking diskspace
my $ChangeLanguage = FALSE;	#A flag for if you are changing the language
my $CurrentFont;
my $MethodButton;
my $PackagesButton;
my $PasswordButton;

sub destroy_window {
        my($widget, $windowref, $w2) = @_;
        $$windowref = undef;
        $w2 = undef if defined $w2;
        0;
}

sub create_standard_entry {
	my($hbox) = create_standard_hbox( 10 , $_[2]);

	my($label) = new Gtk::Label $_[0];
	$label->set_alignment(0.0,0.5);
	$hbox->pack_start($label, 0, 1, 0);
	$label->show;

	my($entry) = new Gtk::Entry;
	$entry->set_usize(0, 20);
	$entry->set_text("$_[1]");
	$hbox->pack_start($entry, 1, 1, 0);
	$entry->show;

	return $entry;
}

sub my_separator {
	my($box1) = @_;

	my($separator) = new Gtk::HSeparator;
	$box1->pack_start($separator, 0, 1, 0);
	$separator->show;

	my($box2) = create_standard_hbox( 10 , $box1, 0, 1, 0 );
	return $box2;
}

sub create_standard_window {
	if ( defined $_[0] ) { $_[0]->destroy; return; }
	$_[0] = new Gtk::Window "toplevel";
	$_[0]->set_uposition($_[1],$_[2]);
	if ( ! ( $_[3] == -1 )) {
		print "Setting window size to $_[3], $_[4]\n";
		$_[0]->set_usize($_[3],$_[4]);
	}
	$_[0]->signal_connect("destroy", \&destroy_window, \$_[0]);
	$_[0]->signal_connect("delete_event", \&destroy_window, \$_[0]);
	$_[0]->set_title( "$_[5]" );
	$_[0]->border_width(0);
	$_[0]->grab_focus;
	$_[0]->show;
	$CurrentWindow = $_[0];
}

sub create_standard_vbox {
	my( $item );
	$item = new Gtk::VBox(0,0);
	$item->border_width( $_[0] );
	if( defined $_[1] ) {
		if( defined $_[2] ) {
			$_[1]->pack_start($item, $_[2], $_[3], $_[4] );
		} else {
#			$_[1]->add($item);
		}
	} else {
		$CurrentWindow->add($item);
	}
	$item->show;
	return $item;
}

sub create_standard_hbox {
	my( $item );
	$item = new Gtk::HBox(0,10);
	$item->border_width( $_[0] );
	if( ! defined $_[1] ) {
		$CurrentWindow->add($item);
	} elsif ( ! defined $_[2] ) {
		$_[1]->add($item);
	} else {
		$_[1]->pack_start($item, $_[2], $_[3], $_[4] );
	}
	$item->show;
	return $item;
}

sub create_standard_label {
	my($label) = new Gtk::Label $_[0];
#	$label->set_alignment(0.0,0.5);
	if( ! defined $_[2] ) {
		$_[1]->add($label);
	} else {
		$_[1]->pack_start($label, $_[2], $_[3], $_[4] );
	}
	$label->show;
	return $label;
}

sub create_standard_button {
	my( $button ) = new Gtk::Button( $_[0] );
#	$_[0]->can_default(1);
	if( ! defined $_[1] ) {
		$button->show;
		return $button;
	}
	if( ! defined $_[2] ) {
		$_[1]->add($button);
	} else {
		$_[1]->pack_start($button, $_[2], $_[3], $_[4] );
	}
	if( defined $_[5] ) {
		$button->signal_connect('clicked', $_[5] );
	}
	$button->show;
	return $button;
}

sub create_method {
	my($button, $vbox, $hbox, $chk_upg, @buttons, $button_name ) ;
	my($entry, @tmp, $label, $sitename, $text, $device);
	my($string, $destdir, @dir_check, $myURL, %sitenameLookup);

	if (defined $method_window) { destroy $method_window; return; }

	if (! -e ("$out_dir/tmp")) { system ("mkdir -p $out_dir/tmp"); }
	if (! -e ("/tmp/install/tmp")) { system ("mkdir -p /tmp/install/tmp"); }

	create_standard_window( $method_window, 230, 20, 350, 350, $words{Choose_Method} );
	$vbox = create_standard_vbox( 1 );
	$hbox = create_standard_hbox( 1, $vbox, 1, 0, 1 );

	$button = create_standard_button( $words{CDROM}, $hbox, 1, 0, 1 );
	$button->signal_connect('clicked', sub {
		if ( -e "/tmp/install/software/base/") {
			destroy $method_window;
			choose_packages();
			return;
		}
		foreach $device ( "/dev/cdrom", "/dev/scd0", "/dev/scd1", "/dev/hda", "/dev/hdb", "/dev/hdc", "/dev/hdd") {
			system( "umount /tmp/install" );
			system( "mount $device /tmp/install" );
			if ( -e "/tmp/install/software/") {
				$in_dir = "/tmp/install/"; 
				if( ! -e "/dev/cdrom" ) {
					system( "ln -sf $device /dev/cdrom" );
				}
				destroy $method_window;
				choose_packages();
				return;
			}
		}
		$text = "/tmp/install " . $words{No_Install_Files};
		create_text_window( 150, 20, 375, 200, 
			$words{CDROM_Mount_Failed}, $words{Close}, $text);
	});

	$button = create_standard_button( $words{LocalPartition}, $hbox, 1, 0, 1 );
	$button->signal_connect('clicked', sub {
		$in_dir = "/tmp/install/"; 
		if ( ! ( -e "$in_dir/software/base/")) {
			$text = "/tmp/install " . $words{No_Install_Files};
			create_text_window( 150, 20, 375, 200, $words{LocalMountFailed},
				$words{Close}, $text);
		} else {
			destroy $method_window;
			choose_packages();
		}
	});

	$button = create_standard_button( "NFS", $hbox, 1, 0, 1 );
	$button->signal_connect('clicked', sub {
		$in_dir = "/tmp/install/"; 
		$sitename = $myURL->get_text;
		print "i should be running  mount sitename:destdir /tmp/install\n";
		if ( ! ( -e "$in_dir/software/base/")) {
			if( $sitename eq "" ) {
				create_text_window( 150, 20, 375, 200, $words{NFS_Mount_Failed},
					$words{Close}, $words{NFS_instructions} );
			} else {
				create_text_window( 150, 20, 375, 200, $words{NFS_Mount_Failed}, 
					$words{Close}, $words{NFS_badmount_message} );
			}
		} else {
			destroy $method_window;
			choose_packages();
		}
	});

	create_standard_label( $words{URL_help} , $vbox );

	$myURL = create_standard_entry( $words{Site} , "", $vbox );

# Adds known sites.
	create_standard_label( $words{Known_sites} , $vbox );

	my( $list , $scrolled_win, $list_item, $i, $name );
	$scrolled_win = new Gtk::ScrolledWindow(undef, undef);
	$scrolled_win->set_policy(-automatic, -automatic);
	$vbox->pack_start($scrolled_win, 1, 1, 0);
	$scrolled_win->show;

        $list = new Gtk::List;
        $scrolled_win->add_with_viewport($list);
        $list->show;

	chdir("$in_dir/");
	unlink( "$in_dir/SITES" );
	system( "$wget http://ftp.linuxppc.org/SITES" );
	if( -e "$in_dir/SITES" ) { print "Yahoo! I retrived this ok from the server!\n"; } 

	open( SITES , "$in_dir/SITES" ) ;
	print "$in_dir/SITES\n";
	while( <SITES> ) {
		chop( $_ );
		if( $_ eq "" ) { next; }
		@tmp = split( " " , $_ );
		if( ! defined $tmp[1] ) { next; }
		$list_item = new Gtk::ListItem( $_ );
		$sitenameLookup{$list_item} = $tmp[2];
		$list->add($list_item);
		$list_item->show;
        }
#	close( SITES );

	$button = create_standard_button( $words{Try_URL}, $hbox, 1, 1, 0 );
	$button->signal_connect('clicked', sub {
		$in_dir = "/tmp/install/"; 
		$in_method = "http"; 
		$sitename = $myURL->get_text;
		if( defined $list->selection() ) {
			@tmp = split( " " , $list->selection() );
			my( $selectedURL ) = pop( @tmp );
			$ftp_url = $sitenameLookup{ $selectedURL };
			print "Trying selected: $ftp_url\n";
		} else {
			print "Trying $sitename\n";
			$ftp_url = $sitename;
		}

		chdir("$in_dir");
		print "in_dir = $in_dir\n";
		if ( -e ("$in_dir/hdlistinfo")) {
			system "rm -f /$in_dir/hdlistinfo";
			system "rmdir /$in_dir/tmp/";
		}

		print "Getting $ftp_url/RedHat/base/hdlistinfo\n";
		system ("$wget $ftp_url/RedHat/base/hdlistinfo");
		if ( ! ( -e "$in_dir/hdlistinfo")) {
			print "Failed getting $ftp_url/RedHat/base/hdlistinfo\n";
			create_text_window( 150, 20, 275, 200, $words{Connection_Failed},
				$words{Close}, "$sitename \n $words{Bad_Site}" );
		} else { 
			system ("$wget $ftp_url/install/maps/install.master");
			system ("$wget $ftp_url/install/maps/order.master");
			destroy $method_window;
			choose_packages();
		}
	});

	$hbox = create_standard_hbox( 1, $vbox, 1, 0, 1 );
#	$hbox = my_separator($vbox);
	$button = create_standard_button( $words{Setup_Network}, $hbox, 1, 1, 0 );
	$button->signal_connect('clicked', sub {
		destroy $method_window;
		create_net();
	});

	create_standard_button( $words{Cancel} , $hbox, 1, 1, 0, sub {
		$method_window->destroy; 
	});
}

#get_dinfo gets the info for the drives from fdisk -l
sub get_finfo {
	my(@tmp_input);
	my($pnum,$type,$name,$length,$base,$size);
	my($dev_name) = "";

	# ok here we take pdisk output and create known drive hash
	# sounds fun, eh?
	# after that we create visual to modify drives allow it to change
	# then update the drive tables needed
	
	#system pdisk here
	open( PART , "/proc/partitions" );
	unlink "/tmp/pdisk.out";

	#system pdisk here -- this hangs if audio or hybrid cd is in drive
	#print "Running  * fdisk -l\n";
	#system "fdisk -l > /tmp/pdisk.out 2> /tmp/pdisk.err";
	while( <PART> ) {
		chop( $_ );
		if( $_ eq "" ) { next; }
		@tmp_input = split( " " , $_ );
		if( $dev_name eq substr( $tmp_input[3] , 0 , 3 ) ) { 
			print "running fdisk on /dev/$dev_name\n"; 
			system( "fdisk -l /dev/$dev_name >> /tmp/pdisk.out" );
		}
		$dev_name = $tmp_input[3];
	}
	close( PART );

	open(DISKF,'/tmp/pdisk.out');
	
	while ( <DISKF> ) {
		chop();
		#if Disk line - store dev entry var
		if (/^Disk/) {
			@tmp_input = split(/\:/);
			$_ = $tmp_input[0];
			@tmp_input = split(/\//);
			$dev_name = $tmp_input[2];

			#print "Found drive :/dev/$dev_name\n";
			next;
		}
					# if /dev/ store info for dev part
					# but not if  #: @
#	   	next if (/[0-9]: @/);	# ^----
		$name = '';
		$type = '';
		$size = '';
		if (/^\/dev\//) {
			#make fdisk line useful
			#other stuff too
			@tmp_input = split(/\s+/);

			$pnum = chop($tmp_input[0]);
			if ($tmp_input[1] =~ /\*/) {
				splice(@tmp_input,1,1);
			}

			$length = $tmp_input[3];
			$base = $tmp_input[1];
			$type = join(' ',@tmp_input[5..$#tmp_input]);

			$drive_hash{$dev_name}{$pnum}[0] = $type; 
			$drive_hash{$dev_name}{$pnum}[1] = $name; 
			$drive_hash{$dev_name}{$pnum}[2] = $length; 
			$drive_hash{$dev_name}{$pnum}[3] = $base; 
			$drive_hash{$dev_name}{$pnum}[4] = $size; 
		}
	}
	close (DISKF);
}

#get_dinfo gets the info for the drives from pdisk -l
sub get_pinfo {
	my(@tmp_input);
	my($pnum,$type,$name,$length,$base,$size);
	my($dev_name) = "";

	# ok here we take pdisk output and create known drive hash
	# sounds fun, eh?
	# after that we create visual to modify drives allow it to change
	# then update the drive tables needed
	
	#system pdisk here
	open( PART , "/proc/partitions" );
	unlink "/tmp/pdisk.out";

	#system pdisk here -- this hangs if audio or hybrid cd is in drive
	#print "Running  * pdisk -l\n";
	#system "pdisk -l > /tmp/pdisk.out 2> /tmp/pdisk.err";
	while( <PART> ) {
		chop( $_ );
		if( $_ eq "" ) { next; }
		@tmp_input = split( " " , $_ );
		if( $dev_name eq substr( $tmp_input[3] , 0 , 3 ) ) { 
			print "running pdisk on /dev/$dev_name\n"; 
			system( "pdisk -l /dev/$dev_name >> /tmp/pdisk.out" );
		}
		$dev_name = $tmp_input[3];
	}
	close( PART );

	open(DISKF,'/tmp/pdisk.out');
	
	while ( <DISKF> ) {
		chop();
		#if partition map line store dev entry var
		if (/^Partition map/) {	#
			@tmp_input = split(/\'/);
			$_ = $tmp_input[1];
			@tmp_input = split(/\//);
			$dev_name = $tmp_input[2];

			#print "Found drive :/dev/$dev_name\n";
			next;
		}
					# if #: store info for dev part
					# but not if  #: @
	   	next if (/[0-9]: @/);	# ^----
		$name = '';
		$type = '';
		$size = '';
		if (/[0-9]:/) {
			#make pdisk line useful
			#other stuff too

			@tmp_input = split(/:/);
			$pnum = $tmp_input[0];
			while ($pnum =~ /\s+/) { $pnum=substr($pnum,1) }
			#$pnum = join ("p",$tmp_input[0]);
			#print "/dev/$dev_name :part # $tmp_input[0] - ";

			$_ = $tmp_input[1];
			@tmp_input = split(/\s+/);
                        while ( ! ($tmp_input[0]) ) { 
				shift(@tmp_input);
			}

			if ($tmp_input[$#tmp_input] =~ /\)/) {
				if (!($tmp_input[$#tmp_input] =~ /[GM]/)) {
				    $tmp_input[$#tmp_input-1] .= pop(@tmp_input);
				}
				if (!($tmp_input[$#tmp_input] =~ /\(/)) {
				    $tmp_input[$#tmp_input-1] .= pop(@tmp_input);
				}
				$size = pop(@tmp_input);
			}
			$base = pop(@tmp_input);
			pop(@tmp_input);
			$length = pop(@tmp_input);
		
			if ( $tmp_input[0] =~ /\*/ ) {
				my(@tmpa) = split(/\*/, shift(@tmp_input) );
				$type = shift(@tmpa);
                        	$name .= shift(@tmpa) . " ";
			} else {
				$type = shift(@tmp_input);
			}
                	while ( scalar(@tmp_input) )	{
				$name .= shift(@tmp_input) . " ";
                	}
			chop $name;
			$drive_hash{$dev_name}{$pnum}[0] = $type; 
			$drive_hash{$dev_name}{$pnum}[1] = $name; 
			$drive_hash{$dev_name}{$pnum}[2] = $length; 
			$drive_hash{$dev_name}{$pnum}[3] = $base; 
			$drive_hash{$dev_name}{$pnum}[4] = $size; 
		} else {
			if (/Number of Blocks/) {
				@tmp_input = split(/=/);
				$_ = $tmp_input[2];
				@tmp_input = split(/ /);
#				print "/dev/$dev_name:  $tmp_input[0] blocks $tmp_input[1]\n";
			}
		}
	}
	close (DISKF);
}

sub mknod {
	my( $i , $j, $path ) = @_;
	my( $majorid );
	if( -e "$path/$i$j" ) { return; }
	print "Making missing dev entry $i$j\n";
	if( $i eq "hda" ) {
		system "mknod $path/$i$j b 3 $j";
	}
	if( $i eq "hdb" ) {
		$majorid = $j + 64;
		system "mknod $path/$i$majorid b 3 $majorid";
	}
	if( $i eq "hdc" ) {
		system "mknod $path/$i$j b 22 $j";
	}
	if( $i eq "hdb" ) {
		$majorid = $j + 64;
		system "mknod $path/$i$majorid b 22 $majorid";
	}
}

sub create_mount {
	my @usedrive  = @_;
	my (%mountwlist, %mke2wlist, @titles, $button, $cancel);
	my ($box1, $box2, $cb_mke2, $scw, $table, $text1, $entry, $crow);
	my(@swap_list, $numparts, $i, $j, @device_order);
	my($use_pdisk) = 1;

	if( defined $mount_window ) { $mount_window->destroy; return; }
	#check if prep or chrp install
	if ($prep_install) {
		$use_pdisk = 0;
	}

	if ($use_pdisk) {
		&get_pinfo();
	} else {
		&get_finfo();
	}

    if ($usedrive[0] =~ /^Gtk/ ) {
	@usedrive = ();
	foreach $i (sort keys(%drive_hash)) { push(@usedrive,$i) }
    }

    #set $numparts equal to number of partitoions shown plus title row
    $numparts = 1;
	my $unix_drive;
    foreach $i (sort(@usedrive)) {
		foreach $j (sort keys(%{$drive_hash{$i}})) {
#			if ( ! defined $drive_hash{$i}{$j}[0] ) { next; }
			if ( $drive_hash{$i}{$j}[0] eq "Apple_UNIX_SVR2" ) {
				$unix_drive = "TRUE";
			}
   			next if ($drive_hash{$i}{$j}[0] eq 'Apple_partition_map');
			next if ($drive_hash{$i}{$j}[0] eq 'Apple_Driver43');
			next if ($drive_hash{$i}{$j}[0] eq 'Apple_Driver_ATA');
			next if ($drive_hash{$i}{$j}[0] eq 'Apple_Patches');
			next if ($drive_hash{$i}{$j}[0] eq 'FWB');
			$numparts++;	
		}
    }

	if( ! defined $unix_drive ) {
		&create_text_window( 230, 20, 300, 200, 
		$words{ No_Linux_Partitions }, $words{Close}, $words{ No_Linux_Partitions_Text } ) ;
		return;
	}

    if ($prep_install) {
		@titles = ( $words{Partition}, $words{Type}, $words{Length}, $words{Mount_Point});
    } else {
		@titles = ( $words{Partition}, $words{Name}, $words{Size}, $words{Mount_Point});
    }

	create_standard_window( $mount_window, 75, 25, 550, 345, $words{MountWindowName} );

	#create main vert box for titles row followed by partition rows
	$box1 = create_standard_vbox( 0 );
	$box2 = create_standard_vbox( 10, $box1, 1, 1, 0 );
		
	$scw = new Gtk::ScrolledWindow(undef,undef);
	$scw->border_width(10);
	$scw->set_policy(-automatic, -automatic);
	$box2->pack_start($scw, 1, 1, 0);
	$scw->show;

	$table = new Gtk::Table($numparts, 4, 0);
	$table->set_row_spacings(2);
	$table->set_col_spacings(2);
	$table->set_row_spacing(0,8);
	$scw->add_with_viewport($table);
	$table->show;

	# setup title row
	for $i ( 0 .. (scalar(@titles) - 1) ) {
		$text1 = new Gtk::Text;
		$text1->set_usize(75,20);
		$text1->can_focus(0);
		$text1->insert(undef,$text1->style->black,undef, $titles[$i]);
		$table->attach_defaults($text1, $i, $i+1, 0, 1);
		$text1->show;
	}

	$crow = 1; 				#current row is 2
	#load up the info into the window
	foreach $i (sort(@usedrive)) {
	    for $j (sort keys(%{$drive_hash{$i}})) {
		mknod $i, $j, "/dev";
		next if ($drive_hash{$i}{$j}[0] eq 'Apple_partition_map');
		next if ($drive_hash{$i}{$j}[0] eq 'Apple_Driver43');
		next if ($drive_hash{$i}{$j}[0] eq 'Apple_Driver_ATA');
		next if ($drive_hash{$i}{$j}[0] eq 'Apple_Patches');
		next if ($drive_hash{$i}{$j}[0] eq 'FWB');

	#new stuff
	#("/dev/$i$j",${$dhash{$i}{$j}}[1],${$dhash{$i}{$j}}[4],entry box,mke2fs checkbutton);
		#fill the data 1 2 3
		$text1 = new Gtk::Text;
		$text1->set_usize(55,20);
		$text1->can_focus(0);
		$text1->insert(undef,$text1->style->black,undef, "/dev/$i$j");
		$table->attach_defaults($text1, 0, 1, $crow, $crow+1);
		$text1->show;

		$text1 = new Gtk::Text;
		$text1->set_usize(95,20);
		$text1->can_focus(0);
		if ($prep_install) {
			$text1->insert(undef,$text1->style->black,undef, ${drive_hash{$i}{$j}}[0] );
		} else {
			$text1->insert(undef,$text1->style->black,undef, ${drive_hash{$i}{$j}}[1] );
		}
		$table->attach_defaults($text1, 1, 2, $crow, $crow+1);
		$text1->show;

		$text1 = new Gtk::Text;
		$text1->set_usize(75,20);
		$text1->can_focus(0);
		if ($prep_install) {
			$text1->insert(undef,$text1->style->black,undef, ${drive_hash{$i}{$j}}[2] );
		} else {
			$text1->insert(undef,$text1->style->black,undef, ${drive_hash{$i}{$j}}[4] );
		}
		$table->attach_defaults($text1, 2, 3, $crow, $crow+1);
		$text1->show;

		$entry = new Gtk::Entry;
		$entry->set_text("");

		#This code will check to see what drives are currently mounted
		# <insert that code here, flight home now, must leave! <jwc>

		my( @mountinfo );
		open( MOUNTS, "/proc/mounts" );
		while( <MOUNTS> ) {
			chop( $_ );
			if( $_ eq "" ) { next; }
			@mountinfo = split( " " , $_ );
			if( $mountinfo[2] ne "ext2" ) { next; }
			if( $mountinfo[0] eq "/dev/root" ) { 
				my( $temp , @stuff, $thing, @temp2 );
				chop( $temp = `cat /proc/cmdline` );
				@stuff = split( " " , $temp );
				foreach $thing ( @stuff ) {
					@temp2 = split( "=" , $thing );
					if( $temp2[0] eq "root" ) {
						$mountinfo[0] = $temp2[1];
						$CurrentRoot = $temp2[1];
					}
				}
#				print "Found /dev/root : $CurrentRoot @mountinfo\n";
			}
			if( substr( $mountinfo[1], 0, length( $out_dir ) ) eq $out_dir ) {
				my( $tmp, $junk, $partition ) = split( /\// , $mountinfo[0] );
#				print "$mountinfo[0], $mountinfo[1], $partition\n";
				my( $path ) = substr( $mountinfo[1] , length( $out_dir ) );
				while ( substr( $path, -1 ) eq "/" ) {
					chop $path;
				}
				$path = "/" . $path;
				print "PATH = $path\n";
				$mount_fstab{ "$partition" } = $path;
			}
		}

		print "drive hash = $drive_hash{$i}{$j}[1] \n";
		if ($drive_hash{$i}{$j}[1] =~ /[Ss]wap/ ) {
			$entry->set_text("swap");
			print "swap guessed from partition name = $i$j\n";
		} elsif ($drive_hash{$i}{$j}[0] =~ /[Ss]wap/ ) {
			$entry->set_text("swap");
			print "swap guessed from partition name = $i$j\n";
		} elsif ($drive_hash{$i}{$j}[0] =~ /PPC PReP Boot/) {
			$entry->set_text("PReP Boot");
			print "PReP Boot partition guessed = $i$j\n";
		} else {
			if( exists $mount_fstab{ "$i$j" } ) {
				$entry->set_text( $mount_fstab{ "$i$j" } );
			}
		}
		
		$mountwlist{"$i$j"} = $entry;

		$entry->show;
		$table->attach_defaults($entry, 3, 4, $crow, $crow+1);

		# Add a checkbox for mke2fs and mkswap
		if (($drive_hash{$i}{$j}[1] =~ /[Ss]wap/ ) || ($drive_hash{$i}{$j}[0] =~ /[Ss]wap/ )) {
			$cb_mke2 = new Gtk::CheckButton 'mkswap';
			$cb_mke2->set_state(1);
		} elsif ($drive_hash{$i}{$j}[0] =~ /PPC PReP Boot/ ) {
			$cb_mke2 = new Gtk::CheckButton 'mkboot';
			$cb_mke2->set_state(1);
		} else {
			$cb_mke2 = new Gtk::CheckButton $words{Format};
		}
		if ( ! ($drive_hash{$i}{$j}[0] eq 'Apple_HFS')) {
			$table->attach_defaults($cb_mke2, 4, 5, $crow, $crow+1);
			$cb_mke2->show;
			$mke2wlist{"$i$j"} = $cb_mke2;
		}
		# in here so next will skip it, happy 
		$crow++;
	    } #end new stuff happy more
	}

	#check if swap is already mounted
	open (SWAP,"/proc/swaps");
	my($swap_input);
	while ($swap_input = <SWAP>) {		#if not eof then swap partition that is on
			next if	($swap_input =~ /^File/); 		#Filename just ignore
			my(@swap_array) = split(' ',$swap_input);
			my($dev) = $swap_array[0];
			@swap_array = split("\/",$dev);
			$dev = pop(@swap_array);
			$mountwlist{$dev}->set_text("swap");
			print "swap partition already mounted = $dev\n";
			push(@swap_list, $dev);
		}
	close(SWAP);
	foreach $i (@swap_list) {
		$mke2wlist{$i}->hide;
		$mke2wlist{$i}->set_state(0);
		$mke2wlist{$i}->show;
		while (Gtk::Gdk->events_pending() ) { Gtk->main_iteration(); }
	}
	$box2 = my_separator($box1);

	create_standard_button( $words{FormatMount} , $box2, 1, 1, 0, sub {
				foreach $i (keys(%mountwlist)) {
					my($wref) = $mountwlist{$i}->get_text;
					next if ($wref eq "");
					$mount_fstab{$i} = $wref; #widgets value

					#Check for / partition
					if ($mount_fstab{$i} eq "\/") {
							$root_dev = $i;
					}
					my($cb_wref);
					if (( defined $mke2wlist{$i} ) && ($mke2wlist{$i}->state eq "active")) { 
						$cb_wref = 1;
					}
					$mke2_mount{$i} = $cb_wref; #widgets value
				}
				
				#if root_dev parse it to two vars
				if (defined $root_dev) {
					my (@tmp_root) = split(//,$root_dev);
					$i = shift(@tmp_root);		#device name
					$i .= shift(@tmp_root);		
					$i .= shift(@tmp_root);		
					$j = join ('',@tmp_root);	#partition number
				}

				#if no root partition give warning
				if (!defined $root_dev) {
					create_text_window(230,20,450,300, $words{no_root_title},
						$words{Close}, $words{no_root_warning});
					#do not destroy mount window since info is wrong
					#this might screw everything up
					#$mount_window->destroy;
				} elsif ($drive_hash{$i}{$j}[2] < 500000) {
					#root_dev is not big enough for base install
					create_text_window(230,20,400,300, $words{too_small_title},
						$words{Close}, $words{too_small_warning});
				} else {
					#mount drives here
					mount_drives();

					$mount_window->destroy;
					$PackagesButton->set_sensitive(1);
					choose_packages();
				}
	});
	if( (-e "/live/perldisk/perldisk") || (-e "/usr/bin/perldisk" ) ){
	create_standard_button( $words{Partition_Drives} , $box2, 1, 1, 0, sub {
		print "Starting perldisk\n";
		system "perldisk &";
		if ( defined $mount_window ) { $mount_window->destroy; return; }
	});
	}


	create_standard_button( $words{Recommend} , $box2, 1, 1, 0, sub {
			create_text_window(230,20,500,300, $words{Recommend},
				$words{Close}, $words{Recommend_text});
	});

	create_standard_button( $words{Cancel} , $box2, 1, 1, 0, sub {
		$mount_window->destroy; 
	});

}

sub choose_packages {
	my( $box1, $box2, $scrolled_win, $list, $leaf, $base_dir, $branch );
	my( $set, $rpm, $tmp, @stuff, $size );
	my( $count ) = 0;

	undef( %sets );
	undef( %rpmlisttree );

	%map = ();

	# Here we will read the base dir files

	my(@list_items) = scan_install_master();	# returns list of catergories
	print "items: @list_items\n";
	get_package_info();			# look at package info

	if( -e "$out_dir/var/lib/rpm" ) {
		my($temp) = `rpm -qa --queryformat=\"%{NAME} \" --root=$out_dir`;
		@rpmlistcurrent = split( " " , $temp );
		print "Checking for installed stuff in $out_dir\n";
		$temp = `rpm -qa --queryformat=\"%{NAME} %{BUILDTIME}\" --root=$out_dir`;
		print "Packages already installed: @rpmlistcurrent\n";
	}

	create_standard_window( $packages_window, 230, 20, 300, 321, $words{Choose_Packages} ) || return;
	$box1 = create_standard_vbox( 0 );
	$box2 = create_standard_hbox( 10 , $box1, 1, 1, 0 );

	$scrolled_win = new Gtk::ScrolledWindow(undef, undef);
	$scrolled_win->set_policy(-automatic, -automatic);
	$box2->pack_start($scrolled_win, 1, 1, 0);
	$scrolled_win->show;

        $list = new Gtk::Tree();
	$list->set_selection_mode(-multiple);
	$scrolled_win->add_with_viewport($list);

	$box2 = my_separator($box1);
	create_standard_button( $words{Install} , $box2, 1, 1, 0, \&install_packages );

	create_standard_button( $words{Close} , $box2, 1, 1, 0, sub {
		$packages_window->destroy; 
	});

	create_standard_button( $words{Reset} , $box2, 1, 1, 0, sub {
		my( $set, $key, $count );
		print "Should do some kind of reset to the original selections\n";
		$count = 0;
		foreach $set ( @list_items ) {
			++$count;
			if( $count < 5 ) { 
				$sets{$set}->select;
			} else {
				$sets{$set}->deselect;
			}
		}
		foreach $key ( @rpmlistcurrent ) { 
			if( exists $rpmlisttreereverse{$key} ) {
				$rpmlisttreereverse{$key}->select;
			}
		}
	});

	$box2 = create_standard_hbox( 4 , $box1, 0, 1, 0 );
	$ProgressBar = new Gtk::ProgressBar;
	$ProgressBar->set_usize(350,20);
	$box2->pack_start($ProgressBar,1,1,0);
	$ProgressBar->show;

	$box2 = create_standard_hbox( 4 , $box1, 0, 1, 0 );
	$ProgressEntry = new Gtk::Entry;
	$ProgressEntry->set_usize(0, 20);
	$ProgressEntry->set_text("");
	$box2->pack_start($ProgressEntry, 1, 1, 0);
	$ProgressEntry->show;

	foreach $set ( @list_items ) {
		$sets{$set} = new Gtk::TreeItem( $set );
		$list->add($sets{$set});
#		$sets{$set}->signal_connect('collapse', \&collapsed );
		$sets{$set}->signal_connect('expand', \&expanded );
		$sets{$set}->signal_connect('select', \&selected );
		$sets{$set}->signal_connect('deselect', \&deselected );
#		$sets{$set}->collapse;
		$sets{$set}->show;

		$branch = new Gtk::Tree();
#		$branch->set_selection_mode(-multiple);
		$sets{$set}->set_subtree($branch);
		$branch->show;

#		print "Starting $set\n";
		foreach $rpm ( sort keys( %rpmlist ) ) {
			if( $set ne $rpmlist{$rpm} ) { next; }
			if( exists $hdlistinfo{$rpm} ) {
				@stuff = split ( "\t" , $hdlistinfo{$rpm} );
				$tmp = "$rpm $stuff[4] $stuff[5]";
				$size = $stuff[4] / ( 1024 * 1024 );
				$tmp = sprintf "$rpm     %.2f MB  $stuff[5]", $size;
			} else {
#			print "Not adding $rpm to tree:not in hdlistinfo\n";
				next;	#assume for now files must have hdlistinfo entries
			}
#			print "Adding $rpm to tree\n";
#			if( exists $rpmlisttreereverse{$rpm} ) {
#				print "Already added $rpm to tree\n";
#				next;
#			}
			$leaf = new Gtk::TreeItem( $tmp );
			$branch->add($leaf);
			$leaf->collapse;
			$leaf->hide;
			$rpmlisttree{$leaf} = $rpm;
			$rpmlisttreereverse{$rpm} = $leaf;
			$leaf->signal_connect('select', \&selected );
			$leaf->signal_connect('deselect', \&deselected );
#			$leaf->show;
#			print "$rpm, $rpmlist{$rpm}\n";
		}
		if ($count < 5) {
			$sets{$set}->select;
		}
		++$count;
	}
	close( MAP );

	$list->show;
}

sub expanded {
	my ($key, $key2);
	foreach $key ( keys( %sets ) ) {
		if( $_[0] eq $sets{$key} ) {
			print "expanded $key\n";
			foreach $key2 ( keys( %rpmlisttree ) ) {
#				print "$rpmlisttree{$key2} ";
				if( $key eq $rpmlist{ $rpmlisttree{$key2} } ) {
#					print "$key2 , $rpmlisttree{$key2} ";
					$rpmlisttreereverse{$rpmlisttree{$key2}}->show;
				}
			}
#			print "\n";
		}
	}
}

sub selected {
	my ($key, $key2, @selected);
	foreach $key ( keys( %sets ) ) {
		if( $_[0] eq $sets{$key} ) {
			$CheckDisk = FALSE;
			foreach $key2 ( keys( %rpmlisttree ) ) {
				if( $key eq $rpmlist{ $rpmlisttree{$key2} } ) {
					$rpmlisttreereverse{$rpmlisttree{$key2}}->select;
				}
			}
			$CheckDisk = TRUE;
			check_diskspace();
			return();
		}
	}
	$map{ $rpmlisttree{$_[0]} } = $_[0];
	if( $CheckDisk eq TRUE ) { check_diskspace(); }
}

sub deselected {
	my ($key, $key2);
	foreach $key ( keys( %sets ) ) {
		if( $_[0] eq $sets{$key} ) {
#			print "deselected $key\n";
			$CheckDisk = FALSE;
			foreach $key2 ( keys( %rpmlisttree ) ) {
				if( $key eq $rpmlist{ $rpmlisttree{$key2} } ) {
					$rpmlisttreereverse{$rpmlisttree{$key2}}->deselect;
				}
			}
			$CheckDisk = TRUE;
			check_diskspace();
			return();
		}
	}
	delete $map{ $rpmlisttree{$_[0]} };
	if( $CheckDisk eq TRUE ) { check_diskspace(); }
}

sub check_diskspace {
	my( $key, $size, @stuff, $string, $number );
	foreach $key ( @rpmlistcurrent ) { delete $map{$key}; }

	$number = keys( %map );
	$size = 0;
	foreach $key (keys( %map )) {
		@stuff = split( "\t" , $hdlistinfo{ "$key" } );
		$size += $stuff[4];
	}
	$size = $size / ( 1024 * 1024 );
	$string = sprintf "$number packages: for %.2f MBytes", $size;
#	print "$string\n";
	$ProgressEntry->set_text( $string );
}

sub update_progress {
	++$MasterCounterDone;
	$ProgressBar->update( $MasterCounterDone / $MasterCounter );
	$ProgressBar->hide;
	$ProgressBar->show;
	print "Setting ProgressEntry to $_[0]  $MasterCounterDone of $MasterCounter\n";
	$ProgressEntry->set_text( $_[0] );
	$ProgressEntry->hide;
	$ProgressEntry->show;

#	print "About to update\n";
	while (Gtk::Gdk->events_pending() ) {
		Gtk->main_iteration();
	}
#	print "Done with update\n";
}

sub find_file {
	#Just a simple routine that looks around for a filename
	my $path;
	my $file = $_[0];
	#print "Trying to find file $file\n";

	foreach $path ( "$in_dir", "$in_dir/software/RedHat/base", "$in_dir/software/RedHat/RPMS", "$in_dir/RedHat/RPMS", "$out_dir/tmp/", "$in_dir/software/RedHat/maps" , "$in_dir/RPMS/" , "$in_dir/software" , "$in_dir/maps/" , "/home/new" , "/mnt/cdrom/maps", "/tmp/install/software" ) {
		# print "\tTesting $path/$file\n";
		if ( -e "$path/$file" ) {
			print "FOUND $path/$file!\n";
			return "$path/$file";
		}
	}
	print "Can not find $file\n";
	return $file;
}

sub call_rpm {
	my(@rpmargs,@stuff,$temp,$file);
	my(@order) = @_;
	my($tmpcount) = 0;
	my($force) = " --nodeps --force ";
	my( $filename, $date, $version, $revision, $size, $description, $path);
	my $returned;

	foreach $temp ( @order ) {
		($file,@rpmargs) = split( " " , $temp );
		if( ! exists $map{ "$file" } ) { next; }
		if (! exists $hdlistinfo{ "$file" }) { 
			print "$file appears to be missing.\n"; 
			++$MasterCounterDone;
			next;
		}

		@stuff = split( "\t" , $hdlistinfo{ "$file" } );
		$filename = shift( @stuff );
#		shift( @stuff );
		$date = shift( @stuff );
		$version = shift( @stuff );
		$revision = shift( @stuff );
		$size = shift( @stuff );
		$description = shift( @stuff );
#		print "Order Install $map{ $file } $filename @rpmargs\n";
		update_progress( "$filename - $description" );
		$path = find_file $filename;
		if ( $path eq "" ) {
			# print "$filename is on HFS\n";
			$path = find_file substr( $filename, 0, 31 );
		}

		if (($in_method eq "ftp") || ($in_method eq "http")) {
#			print "Running  * $wget $ftp_url/RedHat/RPMS/$filename\n";
			system "$wget $ftp_url/RedHat/RPMS/$filename -P $out_dir/tmp/";
		}
		if ( $path eq "" ) {
			$path = find_file $filename;
		}
		if ( $path eq "" ) {
			$path = find_file substr( $filename, 0, 31 );
		}
		if ( $path eq "" ) {
			# This will probably not really work. Should print error here for hollis :)
			$path = $filename;
		}
		print "Running  * rpm -hvi --root=$out_dir $path @rpmargs\n";
		$returned = system ( "rpm -hvi --root=$out_dir $path @rpmargs $force" );  
		if( $returned ne 0 ) {
			# print "RPM FAILED: RETURNED $returned\n";
			system "xmessage $filename failed to install. \\\nrpm exited with $returned.";
			# will return 2 if you control-c it
		}
		delete $map{ "$file" };
		sleep 1;
	}
	undef @rpmargs;

	print "number of packages so far = $tmpcount \n";

	system( "sync" );
	update_progress( $words{Done} );
	$ProgressBar->update( 1 );
	print " I counted $tmpcount RPMS that i tried to install.\n";
	$PasswordButton->set_sensitive(1);
}

sub install_packages {
	my($button,$vbox,$pbar,$i,$set,$file,$rpm,$key,$temp);
	my(@stuff,@rpmargs,$tmpcount,$base_dir);
	
	#take out installed packages from install map
	foreach $key ( @rpmlistcurrent ) { delete $map{$key}; }

	#how many
	my($rpmcount) = 1;
	foreach $rpm (keys %map) { $rpmcount++; }
	$MasterCounter = $rpmcount + 1;
	$MasterCounterDone = 0;

	print "Here we set up the filesystem: \n";
	print "Running  * mkdir -p $out_dir/var/lib/rpm $out_dir/etc $out_dir/usr\n";
	system( "mkdir -p $out_dir/var/lib/rpm $out_dir/etc $out_dir/usr" );

	#create X11 link in usr
	print "Linking X11 to X11R6 in usr\n";
	system( "ln -sf /usr/X11R6 $out_dir/usr/X11" );

	# get install order
	my(@order) = get_install_order();	

	if (( $in_method eq "ftp" ) || ($in_method eq "http")) {
		chdir "$in_dir";
	} else {
		chdir "$in_dir/software/RedHat/RPMS";
	}

	# Install the packages here and in the right order
	call_rpm( @order , keys( %map ) );

	# If new install: run the new install fixes....
	if( ( -e "/live/lib/" ) && ( ! -e "$out_dir/etc/fstab" ) ) {
		print "This seems like a new install.\n";
		finish_new_install();
		create_passwd();
	} else {
		print "This doesn't seem to be a new install, \n";
		print "so I'm not going to run the fixes.\n";
	}
}

sub finish_new_install {
	print "Writing out fstab to $out_dir/etc/\n";
	make_fstab();

	print "Copying X settings to $out_dir\n";
	my $blah = readlink "/root/bin/X";
	my @stuff = split /\// , $blah;
	my $file = pop( @stuff );
	print "X server is $blah file is $file\n";
	if (( $file eq "Xpmac" ) || ( $file eq "XF68_FBDev" )) {
	} else {
		if( -e "/ram1/$file" ) {
			system "cp /ram1/$file $out_dir/usr/X11R6/bin/";
		} elsif ( -e "/mnt/cdrom/live/bin/$file" ) {
			system "cp /mnt/cdrom/live/bin/$file $out_dir/usr/X11R6/bin/";
		}
	}
	system "ln -sf /usr/X11R6/bin/$file $out_dir/etc/X11/X";
	system("cp -a /etc/X11/XF86Config $out_dir/etc/X11/");
	system("cp -a /etc/sysconfig/mouse $out_dir/etc/sysconfig/");
	system("cp -a /etc/sysconfig/keyboard $out_dir/etc/sysconfig/");
	system("cp -a /dev/mouse $out_dir/dev/mouse");
	system("touch $out_dir/etc/sysconfig/keyboard");

	# FIX /etc/X11/xinit/xinitrc and xdm/Xsession
	print "\nDOING $VERSION version FIXES to xinit, Xsession, and bashrc\n\n";
	system("cp -a /etc/X11/xinit/xinitrc $out_dir/etc/X11/xinit/");
	system("cp -a /etc/X11/Xsession $out_dir/etc/X11/xdm/");

	if( -e "/dev/cdrom" ) {
		system("cp -a /dev/cdrom $out_dir/dev/cdrom");
	}

	# Add aliases to /etc/bashrc
	open( BASHRC , ">>/$out_dir/etc/bashrc" );
	print BASHRC "alias lf=\"ls -aCF\"\n";
	print BASHRC "alias ll=\"ls -alF\"\n";
	print BASHRC "alias pa=\"ps -axuw\"\n";
	print BASHRC "PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin:/usr/local/bin:/usr/local/sbin:/usr/games:\$HOME/bin\n";
	print BASHRC "export PATH\n";
	close( BASHRC );

	write_passwd("");

	#net_set is 1 if nfs or ftp install we need write the network files out

	print "Copying network settings to $out_dir\n";
	if( ! -e "$out_dir/etc/hosts" ) {
		system("cp /etc/hosts $out_dir/etc/"); }
	if( ! -e "$out_dir/etc/resolv.conf" ) {
		system("cp  /etc/resolv.conf $out_dir/etc/resolv.conf"); }
	if( ! -e "$out_dir/etc/sysconfig/network" ) {
		system("cp  /etc/sysconfig/network $out_dir/etc/sysconfig/network"); }
	system("cp -a /etc/sysconfig/network-scripts/ifcfg-eth* $out_dir/etc/sysconfig/network-scripts/"); 
	system("cp -a /etc/pam.d/passwd $out_dir/etc/pam.d/passwd");

	# Fix /var/spool/mqueue permissions so anyone can send mail
	if( -e "$out_dir/var/spool/mqueue" ) {
		system( "chmod 755 $out_dir/var/spool/mqueue" );
	}

	# Netscape rpm may not have made icon for itself
	if( ! -e "$out_dir/etc/X11/applnk/Internet/netscape-communicator.desktop" ) {
		system "mkdir -p $out_dir/etc/X11/applnk/Internet/";
		open NET , ">$out_dir/etc/X11/applnk/Internet/netscape-communicator.desktop";
		print NET "[Desktop Entry]\nName=Netscape Communicator\n";
		print NET "Comment=Netscape Communicator World Wide Web Browser, E-mail and News client\n";
		print NET "Exec=/usr/bin/netscape\nIcon=netscape.png\nTerminal=0\n";
		print NET "Type=Application";
		close NET;
	}

	if ( ($prep_install) && (defined($prepboot)) ) {
		if ($mke2_mount{$prepboot}) {
			#prepboot exists and was clicked
			print "It looks like /dev/$prepboot is the PPC PReP Boot\n";
			print "Running	* dd if=/tmp/install/PReP.zImage of=/dev/$prepboot\n";
			system("dd if=/tmp/install/PReP.zImage of=/dev/$prepboot");
		}
	}

	# Make sure all the devices exist
	my( @usedrive, $i, $j );
	foreach $i (sort keys(%drive_hash)) { push(@usedrive,$i) }
	foreach $i (sort(@usedrive)) {
	    for $j (sort keys(%{$drive_hash{$i}})) {
			mknod $i, $j, "$out_dir/dev";
		}
	}

	# Update xli.pl manually
	system "cp -a /root/bin/xinstaller /usr/X11R6/bin/";
	system "cp -a /root/bin/English /usr/X11R6/lib/xinstaller/";
	system "echo LinuxPPC 2000 > $out_dir/etc/redhat-release";
}

sub create_passwd {
	my($box1,$box2,$entry,$entry2,$button,$separator,$i,$buffer,$label);
	
	# ok here there will be two entry fields with no echo
	# new root passwd typed in both then 'set' button will
	# compare the entries then if the same set new install root passwd

	create_standard_window( $passwd_window, 230, 20, 190, 160, "Set root Password" );

	$box1 = create_standard_vbox( 0 );

	$entry = create_standard_entry( $words{Password}, "", $box1 );
	$entry->set_visibility(0);
	
	$entry2 = create_standard_entry($words{Again}, "", $box1 );
	$entry2->set_visibility(0);

	my_separator($box1);

	$button = new Gtk::Button $words{Set_password};
	$button->can_focus(0);
	$button->can_default(1);
	$button->signal_connect("clicked", sub { 
		my(@cmp_list) = ();
		my($tmp) = $entry->get_text;
		push(@cmp_list,$tmp);
		$tmp = $entry2->get_text;
		push(@cmp_list,$tmp);
		if ($cmp_list[0] eq $cmp_list[1]) {
			print "They match!\n";
			print "Setting root passwd\n";
			$root_passwd = $cmp_list[0];
			write_passwd($root_passwd);
			destroy $passwd_window;
		} else {
			$entry->set_text("");
			$entry2->set_text("");
		}
	});
	$box1->pack_start($button, 1, 1, 0);
	$button->show;

	create_standard_button( $words{Cancel} , $box1, 1, 1, 0, sub {
		$passwd_window->destroy; 
	});
}

sub create_bootx {
	my( $text );
	$text  = $words{BootX_message} . "\n\n$CurrentRoot";
	create_text_window( 230, 20, 400, 200, $words{Using_BootX}, $words{Close}, $text);
}

sub create_text_window {
	my($box1,$box2,$button,$separator,$table,$hscrollbar,$vscrollbar,$text);
	
	create_standard_window( $cngrat_window, $_[0], $_[1], $_[2], $_[3], $_[4] ) || return;

	$box1 = create_standard_vbox( 0 );
	$box2 = create_standard_vbox( 10, $box1, 1, 1, 0 );

	$table = new Gtk::Table(2,2,0);
	$table->set_row_spacing(0,2);
	$table->set_col_spacing(0,2);
	$box2->pack_start($table,1,1,0);
	$table->show;
		
	$text = new Gtk::Text(undef,undef);
	$table->attach_defaults($text, 0,1,0,1);
	show $text;
		
	$hscrollbar = new Gtk::HScrollbar($text->hadj);
	$table->attach($hscrollbar, 0, 1,1,2,[-expand,-fill],[-fill],0,0);
	$hscrollbar->show;

	$vscrollbar = new Gtk::VScrollbar($text->vadj);
	$table->attach($vscrollbar, 1, 2,0,1,[-fill],[-expand,-fill],0,0);
	$vscrollbar->show;
		
	$text->freeze;
	$text->realize;
	
	$text->insert(undef,$text->style->black,undef, $_[6] );
	
	$text->thaw;

	$box2 = my_separator($box1);
		
	create_standard_button( $_[5] , $box2, 1, 1, 0, sub {
		$cngrat_window->destroy; 
	});
}

sub get_install_order {
	my( @order );

	my $path = find_file "order.master";
	if ( $path ne "" ) {
		open (MAP, "$path");
	} else {
		print "order.master does not exist\n";
	}

        while( <MAP> ) {
                chop( $_ );
                if( $_ eq "" ) { next; }
                push( @order, $_ );
        }
	return @order;
}

sub get_package_info {
	my( @stuff, $filename, $date, $version, $revision, $size, $description, $path);

	$path = find_file "hdlistinfo";
	if ( $path ne "" ) {
		open (INFO, "$path");
	} else {
		print "hdlistinfo does not exist\n";
		return;
	}

        while(<INFO>) {
                my($key, $value) = split( "\t" , $_ );
		@stuff = split( " " , $value );
		$filename = shift( @stuff );
		shift( @stuff );
		$date = shift( @stuff );
		$version = shift( @stuff );
		$revision = shift( @stuff );
		$size = shift( @stuff );
		$description = join( " ", @stuff );
                $hdlistinfo{$key} = "$filename\t$date\t$version\t$revision\t$size\t$description";
		if( ! exists $rpmlist{$key} ) { 
#			print "$key "; 
			$rpmlist{$key} = "Miscellaneous";
		}
        }
#	print "are all not in install.master yet.\n";
        close(INFO);
}


sub scan_install_master {
	my( @stuff, @master, $set, $rpm, $temp, $path );

	$path = find_file "install.master";
	if ( $path ne "" ) {
		open (MAP, "$path");
	} else {
		print "install.master does not exist\n";
		return;
	}

	undef %map;
	while( <MAP> ) {
                chop( $_ );
                if( $_ eq "" ) { next; }
                ( $set , $temp ) = split( ":" , $_ );
        #       $set = shift @stuff );
                @stuff = split( " " , $temp );
		push(@master,$set);
                foreach $rpm ( @stuff ) {
			if( exists $rpmlist{$rpm} ) { next; }
			$rpmlist{$rpm} = $set;  # Add to rpm master list
                        foreach $temp ( @ARGV ) {
                                if( $set eq $temp ) {  $map{ "$rpm" } = $set; }
                        }
                }
        }
        close( MAP );

	#dir read stuff

	#possibly add an all option here to filenames array
	return @master , "Miscellaneous";
}

sub mount_drives {
	# read through %mount_fstab hash mounting drive to install to
	# and also deal with turning on swap
	my($sys_line,$i,$swap_dev,$swapon);
	my($j,$p);
	my( %mount_point, @mount_order );

	system ("mkdir -p $out_dir/tmp");

	# This code sorts out the drives to mount based on the mountpoint
	foreach $i (sort keys(%mount_fstab)) {
		$mount_point{ $mount_fstab{$i} } = $i;
	}
	foreach $i (sort keys(%mount_point)) {
		@mount_order = ( @mount_order , $mount_point{ $i } );
	}
	print "Final mount order = @mount_order\n";

	foreach $i ( @mount_order ) {
		print "mount_fstab key = $i \n";
		#create sys_line
		if ($mount_fstab{$i} =~ /[Ss]wap/) {
			$swap_dev = $i;
			next;
		} elsif ($mount_fstab{$i} =~ /PPC PReP Boot/) {
			$prepboot = $i;
			next;
		}
		if (! -e ("$out_dir".$mount_fstab{$i})) { 
			system ("mkdir -p $out_dir/$mount_fstab{$i}"); 
		}
		# run mke2fs on drives that need it
		my(@tmp_array) = split (//,$i);
		$j = $tmp_array[0].$tmp_array[1].$tmp_array[2];
		#get rid off drive name
		shift(@tmp_array);
		shift(@tmp_array);
		shift(@tmp_array);
		$p = join '',@tmp_array;

		if ($mke2_mount{$i} ) {
			print "Running mke2fs -L $mount_fstab{$i} /dev/$i";
			# system "mke2fs -L $mount_fstab{$i} /dev/$i";
		} else {
			print "Not mke2fsing /dev/$i\n";
		}

		$sys_line = "mount /dev/".$i." $out_dir".$mount_fstab{$i};
		print "Running * $sys_line\n";
		system($sys_line);
	}

	# check if swap is on already
	# figure this out
	if ($mke2_mount{$swap_dev}) { 
		# mkswap run mkswap play
		$sys_line = "mkswap /dev/$swap_dev";
		print "  Running * $sys_line\n";
		#print "  \t * $sys_line\n";
		system($sys_line);

		#swapon power activate
		$sys_line = "swapon /dev/$swap_dev";
		print "  Running * $sys_line\n";
		system($sys_line);
	}
}

sub make_fstab {
	my($i);
	#make fstab file in $out_dir/etc/fstab

	my($file_name) = $out_dir."etc/fstab";
	if( -e $file_name ) { return; }
	open (FSTAB,">$file_name");

	my( %mount_point, @mount_order );
	foreach $i (sort keys(%mount_fstab)) {
		$mount_point{ $mount_fstab{$i} } = $i;
	}
	foreach $i (sort keys(%mount_point)) {
		@mount_order = ( @mount_order , $mount_point{ $i } );
		print "new order: $i\n";
	}
	print "Final mount order = @mount_order\n";

	foreach $i ( @mount_order ) {
		if ($mount_fstab{$i} eq "/") {
			print FSTAB ("/dev/$i \t\t",$mount_fstab{$i},"\t\text2\tdefaults\t1 1\n");
		} elsif ($mount_fstab{$i} =~ /[Ss]wap/) {
			print FSTAB ("/dev/$i \t\tswap \t\t\tswap \tdefaults \t0 0\n");
		} else {
			print FSTAB "/dev/$i \t\t",$mount_fstab{$i},"\t\text2\tdefaults\t1 2\n";
		}
	}

	print FSTAB "/dev/fd0\t\t/mnt/floppy\t\text2\tnoauto\t0 0\n";
	print FSTAB "/dev/cdrom\t\t/mnt/cdrom\t\tiso9660\tnoauto\t0 0\n";
	print FSTAB "none\t\t\t/proc\t\tproc\tdefaults\t0 0\n";
	print FSTAB "none\t\t\t/dev/pts\t\tdevpts\tgid=5\,mode=620\t0 0\n";
	close(FSTAB);
}

sub write_passwd {
    my($rootp) = shift;
    my($line);
    my(@pass_file) = ();

    my $salt = "R5";
    my $crypt_passwd = crypt($rootp,$salt);
    my($pass_line) = join(':', "root",$crypt_passwd,"0:0:root:/home/root:/bin/bash");

    open(PASSWD,"$out_dir/etc/passwd");
    while (defined($line = <PASSWD>)) { 
    	next if ($line =~ /^root/);
	push(@pass_file,$line); 
    }
    close (PASSWD);
    open(PASSWD,">$out_dir/etc/passwd");
    print PASSWD "$pass_line\n";

    while ($line = shift(@pass_file)) {
	print PASSWD $line;
    }
    close(PASSWD);
    print "chroot $out_dir pwconv\n";
    system( "chroot $out_dir pwconv" );
}

sub report_add {
	my($key,$devs,$device,$hostnameonly);
	my($net_dir) = $out_dir; 

	if($net_set eq 1) {
		$net_dir = "/";
	}
	$device = $my_widgets{devname}->get_text;

	print "Writing $net_dir/etc/sysconfig/network/ifcfg-$device:\n";
	open (IFCFG, ">$net_dir/etc/sysconfig/network-scripts/ifcfg-$device") || print "Cannot open $net_dir/etc/sysconfig/network-scripts/ifcfg-$device\n";
	print IFCFG "DEVICE=$device\n";

	my($tmp) = $my_widgets{ipaddr}->get_text;
	print IFCFG "IPADDR=$tmp\n";

	$tmp = $my_widgets{netmask}->get_text;
	print IFCFG "NETMASK=$tmp\n";

	if ($my_widgets{onboot}->state eq "active") {
		print IFCFG "ONBOOT=yes\n";
	} else {
		print IFCFG "ONBOOT=no\n";
	}
	print IFCFG "BOOTPROTO=none\n";
	close(IFCFG);

	print "Writing $net_dir/etc/sysconfig/network:\n";
	open (NETCFG, ">$net_dir/etc/sysconfig/network") || print "Cannot open $net_dir/etc/sysconfig/network\n";
	print NETCFG "NETWORKING=yes\n";
	print NETCFG "FORWARD_IPV4=false\n";

	my($hostname) = $my_widgets{hostname}->get_text;
	if( $hostname eq "" ) { $hostname="localhost" }
	print NETCFG "HOSTNAME=$hostname\n";

	$tmp = $my_widgets{gateway}->get_text;
	print NETCFG "GATEWAY=$tmp\n";

	if ($my_widgets{defgtw}->state eq "active") {
		print NETCFG "GATEWAYDEV=$device\n";
	} else {
		print NETCFG "GATEWAYDEV=\n";
	}
	close (NETCFG);

	my($ns) = $my_widgets{dns}->get_text;
	if ($ns eq "") { $ns = "127.0.0.1"; }

	open (RESOLV, ">$net_dir/etc/resolv.conf") || print "Cannot open resolv.conf\n";
	#get domainname from hostname
	my(@parts) = split(/\./, $hostname ); 
	$hostnameonly = shift (@parts);
	$tmp = join ('.', @parts);

	print "domain looks like = $tmp\n";
	print RESOLV "domain $tmp\n";
	print RESOLV "search $tmp\n";
	print RESOLV "nameserver $ns\n";
	close (RESOLV);

	open (HOSTS, ">>$net_dir/etc/hosts") || print "Cannot open /etc/hosts\n";
	$tmp = $my_widgets{ipaddr}->get_text;
	print HOSTS "$tmp    $hostnameonly $hostname\n";
	close (HOSTS);

	if ($net_set eq 1) { 
		print "$in_method installation... setting up network device now \n";
		print "Running  * ifup ifcfg-$device\n";
		system ("ifup ifcfg-$device");
	}
}

sub create_net {
	my($chk_boot,$chk_def,$hostname);
	my($vbox,$hbox,$bbox,$button,$label,$chkbox,$entry);	#local widgets

	create_standard_window( $net_window, 230, 80, -1, 450, $words{Setup_Network} );

	$vbox = create_standard_vbox( 5 );
	$hbox = create_standard_hbox( 5 , $vbox , 0, 1, 0);

	$my_widgets{devname} = create_standard_entry( $words{Device_Name}, "eth0", $vbox );
	$my_widgets{ipaddr} = create_standard_entry( $words{IP_Address}, "192.168.1.1", $vbox );
	$my_widgets{gateway} = create_standard_entry( $words{Gateway}, "192.168.1.254", $vbox );
	$my_widgets{netmask} = create_standard_entry( $words{Netmask}, "255.255.255.0", $vbox );

	$hbox = create_standard_hbox( 5 , $vbox , 0, 1, 0);

	#on boot cbox
		$chkbox = new Gtk::CheckButton $words{On_Boot};
		$hbox->pack_start($chkbox, 1, 0, 1);
		$chkbox->set_state(1);
		$chkbox->show;
		$my_widgets{onboot} = $chkbox;

	#default gtway cbox
		$chkbox = new Gtk::CheckButton $words{Default_Gateway};
		$hbox->pack_start($chkbox, 1, 0, 1);
		$chkbox->set_state(1);
		$chkbox->show;
		$my_widgets{defgtw} = $chkbox;

	$hbox = my_separator($vbox);

	chop( $hostname = `hostname` );
	print "hostname returned $hostname \n";
	if( $hostname eq "(none)" ) { $hostname = "localhost.localdomain"; }
	$my_widgets{hostname} = create_standard_entry($words{Hostname}, "$hostname", $vbox );

	$my_widgets{dns} = create_standard_entry( $words{Nameserver}, "", $vbox );

	$bbox = my_separator($vbox);

	create_standard_button( $words{Activate} , $bbox, 1, 0, 1, \&report_add );
	if( ! -e "/live/lib/" ) {
	create_standard_button( $words{Setup_DHCP} , $bbox, 1, 0, 1, sub {
		print "Running dhcpcd to configure the network\n";
		if( -e "/sbin/dhcpcd" ) {
			system( "dhcpcd" );
		} else {
			create_text_window( 230, 20, 400, 300, $words{welcome_title},
			$words{Close}, $words{DHCP_Warning});
		}
	});
	}

	create_standard_button( $words{Setup_PPP} , $bbox, 1, 0, 1, sub {
		print "Running kppp\n";
		if( -e "/usr/bin/kppp" ) {
			system( "kppp &" );
		} else {
			create_text_window( 230, 20, 400, 300, $words{welcome_title},
			$words{Close}, $words{KPPP_Warning});
		}
	});

	create_standard_button( $words{Close} , $bbox, 1, 0, 1, sub {
		$net_window->destroy; 
	});
}

sub do_exit {
	print "done!\n";
	if( $ChangeLanguage eq TRUE ) { return; }
	if( -e "/live/lib/" ) {
		system( "sync" );
		sleep 1;
		system( "mount -a" );
		sleep 1;
		system( "init 6" );
	}
	Gtk->exit(0);
}

## Create MAIN Window
sub create_main_window {
	my( @buttons, $box1, $scw, $box2, $button, $hbox,
		$separator, $buffer, $label, $i);

	create_standard_window( $main_window, 250, 20, 225, 350, "Configure LinuxPPC" ) || return;
	$main_window->signal_connect("destroy" => \&do_exit);
#	$main_window->signal_connect("destroy" => \&Gtk::main_quit);

	$box1 = create_standard_vbox( 0 );
	$hbox = create_standard_hbox( 0 , $box1, 0, 0, 0 );
	$label = create_standard_label( "Post Install Options" , $hbox, 1, 1, 0 );

	my( $menubar, $menu, $submenu, $menuitem, $name );
	$menubar = new Gtk::MenuBar;
	$hbox->pack_start($menubar, 1, 1, 0);
	$menubar->show;
	
	$menu = new Gtk::Menu;
	$submenu = undef;
	$menuitem = undef;
	
	$menuitem = new Gtk::MenuItem( $words{Launch_xterm} );
	$menu->append($menuitem);
	$menuitem->signal_connect("activate", sub { system "xterm &"; } );
	$menuitem->show;

	$menuitem = new Gtk::MenuItem( $words{Configure_Keys} );
	$menu->append($menuitem);
	$menuitem->signal_connect("activate", sub { system "xmodmap.pl &"; } );
	$menuitem->show;

	$menuitem = new Gtk::MenuItem( $words{Network_Config} );
	$menu->append($menuitem);
	$menuitem->signal_connect("activate", \&create_net );
	$menuitem->show;

	$menuitem = new Gtk::MenuItem( $words{Options_Menu} );
	$menuitem->set_submenu($menu);
	$menubar->append($menuitem);
	show $menuitem;

	$scw = new Gtk::ScrolledWindow(undef, undef);
	$scw->set_policy('automatic', 'automatic');
	$scw->show;
	$scw->border_width(10);			#gtk 1.0 doesnt have this
	$box1->pack_start($scw, 1, 1, 0);

	$box2 = create_standard_vbox( 10, $main_window );
	$scw->add_with_viewport($box2);		#for x86/ppc with new gtk
	
	create_standard_button( "Set Timezone" , $box2, 1, 1, 0, sub {
		system "xterm -e timeconfig &";
	} );

	create_standard_button( "Set Date & Time" , $box2, 1, 1, 0, sub {
		system "timetool &";
	} );

	create_standard_button( "Set Network Settings" , $box2, 1, 1, 0, sub {
		system "netcfg &";
	} );

	create_standard_button( "Configure PPP connection" , $box2, 1, 1, 0, sub {
		system "kppp &";
	} );

	create_standard_button( "Configure runlevels" , $box2, 1, 1, 0, sub {
		system "tksysv &";
	} );

	create_standard_button( "Setup Users & Groups" , $box2, 1, 1, 0, sub {
		system "usercfg &";
	} );

	create_standard_button( "Run Linuxconf" , $box2, 1, 1, 0, sub {
		system "linuxconf &";
	} );

	# $button = create_standard_button( $words{Language}, $box2, 1, 1, 0, \&choose_language );

	$box2 = my_separator($box1);
	
	$button = create_standard_button( $words{ Quit }, $box2, 1, 1, 0, sub {
		Gtk->exit(0);
	} );

}

sub change_font {
	my( $StandardText, $FontSelector );
	$StandardText = new Gtk::Text(undef,undef);
	$FontSelector  = new Gtk::FontSelectionDialog "Font Selection Dialog";
	$CurrentFont = $FontSelector->get_font;
	print "current font is $CurrentFont\n";
	if( $_[0] eq "" ) {
		print "Setting font to helvetica \n";
		$FontSelector->set_font_name( "-misc-fixed-medium-r-semicondensed-*-13-*-*-*-c-*-iso8859-8" );
	} else {
		print "Setting font to $_[0]\n";
		$FontSelector->set_font_name( $_[0] );
	}
	$CurrentFont = $FontSelector->get_font;
	print "got font $CurrentFont\n";
	$StandardText->style->font($CurrentFont);
	print "set font to $CurrentFont\n";
	print "Could have set it to $_[0]\n";
}

sub choose_language {
	my( $box1, $label, $language);
	create_standard_window( $language_window, 230, 20, -1, -1, $words{Choose_Language} );
	$box1 = create_standard_vbox( 0 );
	$label = create_standard_label( $words{Choose_Language} , $box1, 0, 0, 0 );

	foreach $language ( "English" , "Italiano" , "Deutsch", "Portugues" ) {
		create_standard_button( $language , $box1, 1, 1, 0, sub { 
			if( $language eq "Japanese" ) {
				change_font "-jis-fixed-medium-r-normal-*-16-*-*-*-c-*-jisx0208.1983-0";
			} else {
				change_font();
			}
			print "Choose $language\n";
			$ChangeLanguage = TRUE;
			make_word_hash( $language );
			create_main_window;
			create_main_window;
			$language_window->destroy;
			$ChangeLanguage = FALSE;
		} );
	}
	create_standard_button( "Request for help" , $box1, 1, 1, 0, sub { 
		create_text_window( 150, 20, 375, 200, 
			"Request for Help", $words{Close}, $words{Request_for_Help});
	} );
}

sub make_word_hash {
	my( $entry, $key, @stuff );
	print "start make_word_hash\n";
	if( -e "/usr/X11R6/lib/xinstaller/$_[0]" ) {
		open( WORDS , "/usr/X11R6/lib/xinstaller/$_[0]" );
	} elsif ( -e "/root/bin/$_[0]" ) {
		open( WORDS , "/root/bin/$_[0]" );
	}
	while( <WORDS> ) {
		chop $_;
		if( $_ eq "" ) { next; };
		@stuff = split( /	/ , $_ );
		if( defined $stuff[1] ) {
			$words{ $stuff[0] } = pop( @stuff );
			next;
		}
		$entry = $_;
		undef $words{ $entry };
		while( <WORDS> ) {
			chop $_;
			if( $_ eq "end" ) { 
				chop $words{ $entry };
				last;
			}
			$words{ $entry } .= "$_\n";
#			print "$_\n";
		}
	}
	close( WORDS );

#	foreach $key ( keys( %words ) ) { print "$key\n"; }
}

sub check_arch {
	my(@tmp_input);

	open( CPU , "/proc/cpuinfo" );
	while( <CPU> ) {
		chop( $_ );
		if( $_ !~ /^machine/ ) { 
			next; 
		}
		@tmp_input = split(/:/);
		if ($tmp_input[1] =~ /PReP/) {
			close(CPU);
			return 1;
		}
	}
	close(CPU);
	return 0;
}

$ENV{PATH} = "$ENV{PATH}:/sbin:/usr/sbin";    #regular users dont have pdisk

$prep_install = check_arch();
if ($prep_install) {
	print "Looks like a PReP install\n";
} else {
	print "Not a PReP install\n";
}
make_word_hash( "English" );

if( -e "/live/lib/" ) {
	system( "killall -9 xmessage" );
}

create_main_window;

system ("touch /install.run");

main Gtk;
